include \masm32\include\masm32rt.inc

MyTest_A	PROTO:DWORD,:DWORD,:DWORD,:DWORD
MyTest__B	PROTO:DWORD
MyTest___C	PROTO:DWORD
MyTest____D	PROTO:DWORD

PrologueDef32 macro procname, flags, parambytes, localbytes, reglist, userparams
LOCAL tmp$
if (parambytes+localbytes) ne 0 or @InStr(,<userparms>,<FORCEFRAME>)
    push ebp
    mov ebp,esp
endif
if localbytes ne 0
    add esp,-localbytes
endif
for reg,reglist
    push reg
endm
ifndef pd32chk
	.data?
	pd32chk	dd ?
	.code
endif
    xprocname equ <&procname>
    .data
	tmp$ CATSTR <procname>, <_AccCtr>		; Access Counter for this proc
	tmp$	dd ?
    .code
    pushad
    mov esi, offset tmp$
    .if esi!=pd32chk
    	mov pd32chk, esi
    	and tmp$, 0		; reset access counter
    .endif
    inc tmp$
    .if tmp$<=3			; limit to 5 consecutive prints
	LogIt CATSTR xprocname, <                        >
	LogIt SUBSTR LogIt, 1, 20
	LogIt CATSTR <print chr$(">, LogIt, < arg1=")>
	LogIt
	print str$([ebp+8]), 13, 10
    .endif
    popad
exitm %localbytes
endm

EpilogueDef32 macro procname, flags, parambytes, localbytes, reglist, userparams
for reg,reglist
    pop reg
endm
if (parambytes+localbytes ne 0) or (@InStr(,<userparms>,<FORCEFRAME>))
    leave ;; mov esp,ebp / pop ebp
endif
if (flags and 10000b)	 ;; if flags bit 5 is set then caller cleans stack
    ret
else
    ret parambytes
endif
xprocname textequ <>
endm

.code

OPTION PROLOGUE:PrologueDef32
OPTION EPILOGUE:EpilogueDef32

start:
	invoke MyTest__B, 1001
	invoke MyTest___C, 2002
	invoke MyTest___C, 2003
	invoke MyTest____D, 3004		; six calls
	invoke MyTest____D, 3005
	invoke MyTest____D, 3006
	invoke MyTest____D, 3007
	invoke MyTest____D, 3008
	invoke MyTest____D, 3009
	m2m ebx, 100
	.Repeat
		invoke MyTest_A, ebx, 0, 0, chr$("Hello...")
		dec ebx
		if 0
			invoke MyTest__B, ebx	; two calls to different procs,
			test ebx, ebx			; so access counter will be reset
		endif
	.Until Zero?
	invoke MyTest____D, 3010
	invoke MyTest____D, 3011
	getkey
	exit

MyTest_A proc hwnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
  ret
MyTest_A endp

MyTest__B proc arg
ret
MyTest__B endp

MyTest___C proc arg
ret
MyTest___C endp

MyTest____D proc arg
ret
MyTest____D endp

end start
